#ifndef PREAMPLIFIERDIALOG_H
#define PREAMPLIFIERDIALOG_H

#include <QDialog>
#include "Ad5622/Ad5622Config.h"

namespace Ui {
class PreamplifierDialog;
}

class PreamplifierDialog : public QDialog
{
    Q_OBJECT

public:
    explicit PreamplifierDialog(QWidget *parent = nullptr);
    ~PreamplifierDialog() override;
    void reset_gui();

signals: void preamplifierConfigChanged(const Ad5622Config &) const;
public slots: virtual void setPreamplifierConfig(const Ad5622Config &config);

private slots:
    void on_groupBox_toggled(bool checked);
    void on_radioButtonVersion1_toggled(bool checked);
    void on_radioButtonVersion2_toggled(bool checked);
    void on_spinBoxBaseline_valueChanged(int baseline);
    void on_spinBoxLevel_valueChanged(int level);

private:
    Ui::PreamplifierDialog * const ui;
    Ad5622Config config;
};

#endif // PREAMPLIFIERDIALOG_H
