#include "Adc64App.h"

#include <QCommandLineParser>
#include <QCoreApplication>
#include <QPixmap>

Adc64App::Adc64App(int &_argc, char *_argv[]) :
    DaqGuiApp(_argc, _argv),
    pcb_ch_option(QStringList() << "p" << "pcb_ch",
        QCoreApplication::translate("pcb_ch", "enable switching to PCB ch"))
{
}

void Adc64App::setupOptions()
{
    DaqGuiApp::setupOptions();
    options << pcb_ch_option;
}

void Adc64App::processParseResults(QCommandLineParser &parser)
{
    DaqGuiApp::processParseResults(parser);

    so.pcb_ch = parser.isSet(pcb_ch_option);
}

QPixmap Adc64App::getSplashPixmap() const
{
    return QPixmap(":/adc64-splash_v1.png");
}
