#ifndef BMNTRCSIGNALROUTER_H
#define BMNTRCSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"
class DeviceMgrFsm;
class ReadoutAppConfigDb;
class DeviceDispatcher;
class BmnTrcCore;
class RemoteControlServer;
class TrcDeviceGlobal;

#ifdef QT_WIDGETS_LIB
class ConfigurationManager;
class BmnTrcMainWindow;
class DiscoverDialog;
class MStreamStatisticDialog;
class RcCountersModel;
class BmnTrcDeviceChModel;

#include <QMap>
#endif

class BmnTrcSignalRouter: public ReadoutAppSignalRouter
{
    BmnTrcSignalRouter();
    Q_DISABLE_COPY_MOVE(BmnTrcSignalRouter)
public:
    // Singleton
    static BmnTrcSignalRouter & instance()
    {
        // thread-safe since C++11
        static BmnTrcSignalRouter obj;
        return obj;
    }

    void setCore(BmnTrcCore *p);
    void setConfigDb(ReadoutAppConfigDb *p)
    { configDb = p; }
#ifdef QT_WIDGETS_LIB
    void setMainWindow(BmnTrcMainWindow *p);
    void setDeviceChModel(BmnTrcDeviceChModel *p)
    { deviceChModel = p; }
    void setRcCountersModel(int type, RcCountersModel *p)
    { rcCountersModels[type] = p; }
#endif

    void connect_TrcDeviceGlobal(const TrcDeviceGlobal * devGlob);

private:
    void connect_ConfigurationDispatcher() const override;
#ifdef QT_WIDGETS_LIB
    void connect_MainWindow() const override;
#endif
    void connect_RemoteControlServer() const override;

    BmnTrcCore *core = nullptr;
    ReadoutAppConfigDb * configDb = nullptr;
#ifdef QT_WIDGETS_LIB
    BmnTrcMainWindow *mainWindow = nullptr;
    BmnTrcDeviceChModel * deviceChModel = nullptr;
    QMap<int, RcCountersModel *> rcCountersModels;
#endif
};
#endif // BMNTRCSIGNALROUTER_H

