#ifndef CRUSIGNALROUTER_H
#define CRUSIGNALROUTER_H

#include "lib-common/ReadoutAppSignalRouter.h"
class DeviceMgrFsm;
class DeviceDispatcher;
class CruCore;
class CruFsm;
class ReadoutAppConfigDb;
class ReadoutAppConfigDispatcher;
class RemoteControlServer;
class CruDeviceGlobal;

#ifdef QT_WIDGETS_LIB
class ConfigurationManager;
class CruMainWindow;
class DiscoverDialog;
class MStreamStatisticDialog;
class RcCountersModel;

#include <QMap>
#endif

class CruSignalRouter: public ReadoutAppSignalRouter
{
    CruSignalRouter();
    Q_DISABLE_COPY_MOVE(CruSignalRouter)
public:
    // Singleton
    static CruSignalRouter & instance()
    {
        // thread-safe since C++11
        static CruSignalRouter obj;
        return obj;
    }

    void setCore(CruCore *p);
    void setCruFsm(CruFsm *p);
    void setConfigDb(ReadoutAppConfigDb *p)
    { configDb = p; }
    void setReadoutAppConfigDispatcher(ReadoutAppConfigDispatcher *p);
#ifdef QT_WIDGETS_LIB
    void setMainWindow(CruMainWindow *p);
#endif

    void connect_CruDeviceGlobal(const CruDeviceGlobal * devGlob);

private:
    void connect_ConfigurationDispatcher() const override;
#ifdef QT_WIDGETS_LIB
    void connect_MainWindow() const override;
#endif
    void connect_RemoteControlServer() const override;

    ReadoutAppConfigDb * configDb = nullptr;
    ReadoutAppConfigDispatcher * configDispatcher = nullptr;
    CruCore *core = nullptr;
    CruFsm * cruFsm = nullptr;
#ifdef QT_WIDGETS_LIB
    CruMainWindow *mainWindow = nullptr;
#endif
};
#endif // CRUSIGNALROUTER_H

