#include "DreMainWindow.h"
#include <QApplication>
#include <QString>
#include <QDebug>
#include <iostream>

#include "base/Globals.h"
#include "base/SyslogMessageSender.h"

int main(int argc, char *argv[])
{
    QCoreApplication::setOrganizationName(Globals::organizationName);
    QCoreApplication::setOrganizationDomain(Globals::organizationDomain);
    QCoreApplication::setApplicationName("DevRegEdit");

    SyslogMessageSender::instance().install();

    int ret;
    try{
        QApplication a(argc, argv);
        DreMainWindow w;
        w.show();
        ret = a.exec();
    } catch (std::exception &e) {
        std::cerr << "Exception: " << e.what () << std::endl;
    }

    return ret;
}
