#ifndef HRBSPINBOXDELEGATE_H
#define HRBSPINBOXDELEGATE_H

#include <QItemDelegate>

struct DeviceChModelItem;
class QDoubleSpinBox;
class QTimer;

class HrbSpinBoxDelegate : public QItemDelegate
{
Q_OBJECT
public:
    HrbSpinBoxDelegate(QObject *parent = 0);
    QWidget *createEditor(QWidget *parent,
                          const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;
    void setEditorData(QWidget *editor,
                       const QModelIndex &index) const;
    void setModelData(QWidget *editor,
                      QAbstractItemModel *model,
                      const QModelIndex &index) const;
    void updateEditorGeometry(QWidget *editor,
                              const QStyleOptionViewItem &option,
                              const QModelIndex &index) const;

    static void initSpinBox(QDoubleSpinBox *s);

private slots:
    void dataChanged();
    void flushCommitData();

private:
    inline DeviceChModelItem *getItemByIndex(const QModelIndex &index) const;

    QTimer * const commitDataTimer;
    QObject * commitDataWidget = nullptr;
};
#endif // HRBSPINBOXDELEGATE_H
