#ifndef TTBDEVICEGLOBAL_H
#define TTBDEVICEGLOBAL_H

#include "mstream-mreg-dev-global/MstreamMregDevGlobal.h"
#include "TtbStatus.h"

class TtbDevice;

class TtbDeviceGlobal : public MstreamMregDevGlobal
{
    Q_OBJECT
public:
    explicit TtbDeviceGlobal(const DeviceIndex &index, QObject *parent = nullptr);

    TtbStatus getDevStatus() const { return devStatus; }
    TtbStatus getLastMetricDevStatus() const { return lastMetricDevStatus; }
    void updateLastMetricDevStatus() { lastMetricDevStatus = devStatus; }

signals:
    void runError(const DeviceIndex &index, const QString &err) const;

public slots:
    void deviceStatusUpdated(const TtbStatus &status);

private:
    bool isTtbStatusOk(const TtbStatus &status, bool silent = false) const;

private:
    TtbStatus devStatus;
    TtbStatus lastMetricDevStatus;
    bool inRun = false;
};

#endif // TTBDEVICEGLOBAL_H
