/*
**    Copyright 2013-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef UTCTIMESTAMPMODULE_H
#define UTCTIMESTAMPMODULE_H

#include <QtGlobal>
#include "device-modules/BaseDeviceModule.h"

class UtcTimestampModule : public BaseDeviceModule<UtcTimestampModule>
{
public:
    explicit UtcTimestampModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    void setClock();
    quint64 readClock();
    double timestampFrequencyHz() const;

protected:
    void writeClock(quint64 value);

    quint64 ts_write_ts = 0;
};

#endif // UTCTIMESTAMPMODULE_H
