#include <QDebug>
#include <QHostAddress>
#include <QJsonDocument>
#include <QTimer>
#include <iostream>

#include "Core.h"

#include "base/ProgramIndex.h"
#include "base/AbstractConfigConverter.h"
#include "pnp-server/PnpDiscovery.h"
#include "pnp-server/ProgramDescriptionConverter.h"
#include "message-bus/MessagePublisher.h"

namespace {
    constexpr const char *k_key = "PNP";
}

Core::Core(QObject *parent) : QObject(parent)
{
    AbstractConfigConverter<PnpInfoCache>::registerTypes();
    AbstractConfigConverter<ProgramInterfacePeer>::registerTypes();
    AbstractConfigConverter<ProgramDescription>::registerTypes();
    PnpDiscovery::subscribeCacheUpdaed(this);
}

void Core::pnpCacheUpdated(const PnpInfoCache &cache)
{
    MessagePublisher::instance().pub(
        k_key,
        QJsonDocument(QVariant::fromValue(cache).value<QJsonObject>())
            .toJson(QJsonDocument::Compact)
    );

    std::cerr << ".";
}
