#include "EvbGenConfigConverter.h"

#include "EvbGenConfig.h"

constexpr const char *k_numberOfClients = "numberOfClients";
constexpr const char *k_cfgBase = "cfgBase";

constexpr const char *k_preRunWait = "preRunWait";
constexpr const char *k_spill_count = "spill_count";
constexpr const char *k_spillMs = "spillMs";
constexpr const char *k_interspillMs = "interspillMs";
constexpr const char *k_evRate = "evRate";
constexpr const char *k_event_length = "event_length";
constexpr const char *k_eventLengthMax = "eventLengthMax";
constexpr const char *k_useMax = "useMax";

// ===================== GenServerConfig Start =====================

template<>
bool AbstractConfigConverter<GenServerConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<GenServerConfig>::toJsonObject(const GenServerConfig &in)
{
    QVariantMap m;
    m[k_preRunWait] = QVariant::fromValue(in.preRunWait);
    m[k_spill_count] = QVariant::fromValue(in.spill_count);
    m[k_spillMs] = QVariant::fromValue(in.spillMs);
    m[k_interspillMs] = QVariant::fromValue(in.interspillMs);
    m[k_evRate] = QVariant::fromValue(in.evRate);
    m[k_event_length] = QVariant::fromValue(in.event_length);
    m[k_useMax] = QVariant::fromValue(in.useMax);
    m[k_eventLengthMax] = QVariant::fromValue(in.eventLengthMax);
    return fromVariantMap(m);
}

template<>
GenServerConfig AbstractConfigConverter<GenServerConfig>::fromJsonObject(const QJsonObject &m)
{
    GenServerConfig out;
    update_value(m, k_preRunWait, &out.preRunWait);
    update_value(m, k_spill_count, &out.spill_count);
    update_value(m, k_spillMs, &out.spillMs);
    update_value(m, k_interspillMs, &out.interspillMs);
    update_value(m, k_evRate, &out.evRate);
    update_value(m, k_event_length, &out.event_length);
    update_value(m, k_useMax, &out.useMax);
    update_value(m, k_eventLengthMax, &out.eventLengthMax);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<GenServerConfig>::toJsonValue(const GenServerConfig &in)
{
    return toJsonObject(in);
}

template<>
GenServerConfig AbstractConfigConverter<GenServerConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<GenServerConfig>::registerSubTypes()
{
}

// ===================== GenServerConfig End =====================

// ===================== EvbGenConfig Start =====================

template<>
bool AbstractConfigConverter<EvbGenConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<EvbGenConfig>::toJsonObject(const EvbGenConfig &in)
{
    QVariantMap m;
    m[k_numberOfClients] = QVariant::fromValue(in.numberOfClients);
    m[k_cfgBase] = QVariant::fromValue(in.cfgBase);
    return fromVariantMap(m);
}

template<>
EvbGenConfig AbstractConfigConverter<EvbGenConfig>::fromJsonObject(const QJsonObject &m)
{
    EvbGenConfig out;
    update_value(m, k_numberOfClients, &out.numberOfClients);
    update_value(m, k_cfgBase, &out.cfgBase);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<EvbGenConfig>::toJsonValue(const EvbGenConfig &in)
{
    return toJsonObject(in);
}

template<>
EvbGenConfig AbstractConfigConverter<EvbGenConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<EvbGenConfig>::registerSubTypes()
{
    AbstractConfigConverter<GenServerConfig>::registerTypes();
}

// ===================== EvbGenConfig End =====================
