#ifndef EVBGENFSM_H
#define EVBGENFSM_H

#include "fsm/BaseFsm.h"

#include <QMap>

struct EvbGenFsmInput : public BaseFsmInput
{
    int genNum = 0;
    QMap<int, FsmState> genState;
};

class EvbGenFsm : public BaseFsm
{
    Q_OBJECT
public:
    explicit EvbGenFsm(QObject *parent = nullptr);
    virtual bool isTransitionAllowed(const FsmState &toState) const;

public slots:
    void setGenNum(int genNum);
    void setGenState(int id, FsmState st);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    inline EvbGenFsmInput *getInput() {
        return static_cast<EvbGenFsmInput*>(BaseFsm::getInput());
    }
    inline const EvbGenFsmInput *getInput() const {
        return static_cast<const EvbGenFsmInput*>(BaseFsm::getInput());
    }
private:
    bool hasAnyErr() const;
    bool allInState(FsmState st) const;
};

QDebug operator<<(QDebug dbg, const EvbGenFsmInput &in);

#endif // EVBGENFSM_H
