#ifndef EVBGENSIGNALROUTER_H
#define EVBGENSIGNALROUTER_H

#include "lib-common/BaseSignalRouter.h"

class EvbGenCore;
class EvbGenConfigDb;
class EvbGenMainWindow;

class EvbGenSignalRouter : public BaseSignalRouter
{
    EvbGenSignalRouter() {}
    Q_DISABLE_COPY_MOVE(EvbGenSignalRouter)

public:
    // Singleton
    static EvbGenSignalRouter & instance()
    {
        // thread-safe since C++11
        static EvbGenSignalRouter obj;
        return obj;
    }

    void setCore(EvbGenCore *p);
    void setMainWindow(EvbGenMainWindow *p)
    { mainWindow = p; }
    void setEvbGenConfigDb(EvbGenConfigDb * p)
    { configDb = p; }


private:
    virtual void connect_MainWindow() const;
    virtual void connect_RemoteControlServer() const override;

    EvbGenCore *core = nullptr;
    EvbGenMainWindow *mainWindow = nullptr;
    EvbGenConfigDb *configDb = nullptr;
};

#endif // EVBGENSIGNALROUTER_H
