#ifndef GENSERVERCONFIG_H
#define GENSERVERCONFIG_H

#include <QMetaType>

struct GenServerConfig
{
    friend bool operator==(const GenServerConfig &, const GenServerConfig &) = default;
    quint32 getEvCntPerSpill() const {
        return evRate*spillMs/1e3;
    }

    int preRunWait = 1000; // ms

    int spill_count = 2000;
    int spillMs = 1000; // ms
    int interspillMs = 000; // ms
    double evRate = 15e3; // Hz
    int event_length = 100; // ev payload under MpdDeviceHdr, bytes
    bool useMax = false;
    int eventLengthMax = event_length;
};
Q_DECLARE_METATYPE(GenServerConfig)

#endif // GENSERVERCONFIG_H
