#ifndef EVBGENMAINWINDOW_H
#define EVBGENMAINWINDOW_H

#include "lib-common/PnpBaseMainWindow.h"
#include "fsm/FsmState.h"

namespace Ui {
class EvbGenMainWindow;
}

struct RemoteControlServerStatus;

class EvbGenMainWindow : public PnpBaseMainWindow
{
    Q_OBJECT

public:
    explicit EvbGenMainWindow(QWidget *parent = nullptr);
    ~EvbGenMainWindow();

signals:
    void performLocalStart() const;
    void performLocalStop() const;

public slots:
    virtual void onFsmStateChange(const FsmState &state) override;
    void onRunProgressChange(quint64 minEvNum, quint64 runEvNum, int p);
    virtual void onRemoteStatusUpdated(const RemoteControlServerStatus &status);

private slots:
    void on_pushButtonStart_clicked();
    void on_pushButtonStop_clicked();

private:
    void updateGuiEnableStates() const;

    Ui::EvbGenMainWindow *ui;
    bool underRemoteCtrl = false;
};

#endif // EVBGENMAINWINDOW_H
