#ifndef EVBCLIENTCONFIG_H
#define EVBCLIENTCONFIG_H

#include "base/ClientIndex.h"

class QDataStream;
class QDebug;

struct EvBClientConfig
{
    friend bool operator==(const EvBClientConfig &, const EvBClientConfig &) = default;
    QString toString() const { return QString("Client #%1").arg(index.toString()); }
    void checkAndRepair();

    ClientIndex index;
    bool enabled = true;
    quint64 bufSize = 0;
};
Q_DECLARE_METATYPE(EvBClientConfig)

QDebug operator<<(QDebug dbg, const EvBClientConfig &c);
QDataStream &operator<<(QDataStream &out, const EvBClientConfig &r);
QDataStream &operator>>(QDataStream &in, EvBClientConfig &r);

using EvBClientMap = QMap<ClientIndex, EvBClientConfig>;

#endif // EVBCLIENTCONFIG_H
