﻿#ifndef EVBCONFIG_H
#define EVBCONFIG_H

#include <optional>

#include "base/ClientIndex.h"

#include "EvbCombinerConfig.h"
#include "EvBClientConfig.h"
#include "EvbCombinerConfig.h"
#include "EvbEvNumberConfig.h"
#include "EvbFileSplitterConfig.h"
#include "EvbWriterConfig.h"

class QDataStream;
struct ClientIndexEnabledMap;

struct EvBConfig
{
    friend bool operator==(const EvBConfig &, const EvBConfig &) = default;
    ClientIndexEnabledMap getClientIndexEnabledMap() const;
    bool isOutFile() const {return combinerCfg.combinerOut==COMBINER_FILE;}
    bool isOutTcp() const {return combinerCfg.combinerOut==COMBINER_TCP;}
    bool isOutIdle() const {return combinerCfg.combinerOut==COMBINER_IDLE;}
    QString getOutputStr() const;
    void checkAndRepair();

    EvbCombinerConfig combinerCfg;
    EvbWriterConfig writerCfg;
    bool isRemoteEnabled = true;
    bool advancedCounters = false;
    EvbEvNumberConfig evNumCfg;
    quint16 monitorPort = 0;
    EvbFileSplitterConfig fileSplit;
    QMap<ClientIndex, EvBClientConfig> clients;
    bool allowBufferAutoResize = false;
};
Q_DECLARE_METATYPE(EvBConfig)

QDebug operator<<(QDebug dbg, const EvBConfig &c);
QDataStream &operator<<(QDataStream &out, const EvBConfig &r);
QDataStream &operator>>(QDataStream &in, EvBConfig &r);

#endif // EVBCONFIG_H
