#ifndef MSCDEVICEGLOBAL_H
#define MSCDEVICEGLOBAL_H

#include "mstream-mreg-dev-global/MstreamMregDevGlobal.h"
#include "status/MscStatus.h"

class BaseDeviceAppConfig;

class MscDeviceGlobal: public MstreamMregDevGlobal
{
    Q_OBJECT
public:
    MscDeviceGlobal(const DeviceIndex &index, QObject *parent = nullptr);

signals:
    void configChanged(const BaseDeviceAppConfig &newConfig);
    void setConfig(const BaseDeviceAppConfig &newConfig);
    void baseLineUpdated(const DeviceIndex &index, QVector<double> baseLine) const;
    void TempChanged(const DeviceIndex &, double);
    void findBaseLine();

public slots:
    void statusUpdated(const MscStatus &status);

public:
    MscStatus msc_status;
    bool lookForStop = false;
};

#endif // MSCDEVICEGLOBAL_H
