#include "msc-gui/MscMainWindow.h"
#include "metric-sender/MetricSender.h"
#include "base/DaqModule.h"
#include "base/app/DaqGuiApp.h"
#include "base/Globals.h"
#include "mongo/PrintConfigMap.h"
#include "base/app/RunGuard.h"
#include "MscCore.h"

int main(int argc, char *argv[])
{
    Globals::setDaqModule(DaqModule(DaqModule::Type::Msc16Ve));
    DaqGuiApp daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap();

    RunGuard::runSingleOrExit();

    if(daqApp.isGuiApp()) {
        MetricSender::instance().install();

        MscMainWindow *mw(new MscMainWindow);
        mw->show();
    }

    MscCore core;

    return daqApp.exec();
}
