#ifndef MSCHISTWIDGET_H
#define MSCHISTWIDGET_H

#include "device-modules/ModularDeviceConfig.h"
#include "qxw/WaveformPlot.h"
#include "data/MscHistData.h"

namespace Ui {
class MscHistTimeWave;
}

class ConfigKey;
class DeviceIndex;
class WaveformPlot;
class WaveformData;

class MscHistWidget : public WaveformPlot
{
    Q_OBJECT
public:
    explicit MscHistWidget(int hId, bool useLogScale, QWidget *parent = nullptr);
    int getHId() const { return hId; }
    void setXAxisTitle(QString title);
    void setYAxisTitle(QString title);

public slots:
    void updateHistogram(const MscHistData &h);
    void setDeviceConfig(const ConfigKey &key, const ModularDeviceConfig &newConfig);

private:
    void setAScale(const MscHistData &h);
    void setTitleName(QString name);

    int hId;
    ModularDeviceConfig config;
};

#endif // MSCHISTWIDGET_H
