#include "SlowControlConfig.h"

#include <QDebug>
#include <QDataStream>

bool operator==(const SlowControlConfig &l, const SlowControlConfig &r)
{
    return l.enabled == r.enabled &&
            l.port == r.port;
}

QDebug operator<<(QDebug dbg, const SlowControlConfig &r)
{
    dbg.noquote().nospace()
        << "SlowControlConfig("
        << "enabled: " << r.enabled
        << ", port: " << r.port
        << ")";
    return dbg;
}

QDataStream &operator<<(QDataStream &out, const SlowControlConfig &r)
{
    out
            << r.enabled
            << r.port;
    return out;
}

QDataStream &operator>>(QDataStream &in, SlowControlConfig &r)
{
    in
            >> r.enabled
            >> r.port;
    return in;
}
