#ifndef VMETRIGFSM_H
#define VMETRIGFSM_H

#include "fsm/DeviceMgrFsm.h"
#include "base/DeviceIndex.h"

#include <QMap>

struct VmeTrigFsmInput : public DeviceMgrFsmInput
{
    DeviceIndexSet wrCheckSet;
    QMap<DeviceIndex, bool> wrOk;
};

class VmeTrigFsm : public DeviceMgrFsm
{
    Q_OBJECT
public:
    VmeTrigFsm(QObject *p);

public slots:
    void setWrState(const DeviceIndex &index, bool ok);
    void setWrCheckSet(DeviceIndexSet wrCheckSet);

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    bool allWrOk();
    inline VmeTrigFsmInput *getInput() {
        return static_cast<VmeTrigFsmInput*>(BaseFsm::getInput());
    }
    inline const VmeTrigFsmInput *getInput() const {
        return static_cast<const VmeTrigFsmInput*>(BaseFsm::getInput());
    }
};

QDebug operator<<(QDebug dbg, const VmeTrigFsmInput &in);

#endif // VMETRIGFSM_H
