#ifndef CALCONFIG_H
#define CALCONFIG_H
#include "histogramm/DeviceCalibration.h"

#include <QString>
#include <QMap>

class DeviceIndex;
class QSettings;

class CalConfig
{
public:
    virtual ~CalConfig() {}
    void calibrationUpdated(QMap<DeviceIndex, DeviceCalibration> newCal, QString baseDir);
    virtual void reloadCalibration(const QString &separateInlFolder);
    virtual void reloadCalibration();

protected:
    void reloadCalibration(QSettings &s);
    QString getInlSectionStr(const DeviceIndex &devIndex); // FIXME: make const
    DeviceIndex getDevIndexByGroup(QString groupStr, QString &type); // FIXME: make const, const arguments

public:
    QMap<DeviceIndex, DeviceCalibration> allCal;
};

#endif // CALCONFIG_H
