/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RCPROGRAMCONFIG_H
#define RCPROGRAMCONFIG_H

#include "base/RcRunId.h"
#include <QMetaType>

struct RcProgramConfig
{
    friend bool operator==(const RcProgramConfig &, const RcProgramConfig &) = default;

    bool runEnable = false;
    int localRunNumber = 0; // previous run number
    bool allowRemoteControl = true;
};

Q_DECLARE_METATYPE(RcProgramConfig)

QDebug operator<<(QDebug dbg, const RcProgramConfig &r);

#endif // RCPROGRAMCONFIG_H
