#ifndef RUNDOCUMENT_H
#define RUNDOCUMENT_H

#include <QDateTime>
#include <QMap>
#include <QMetaType>
#include <QJsonObject>

#include "base/ClientIndex.h"
#include "base/DeviceIndex.h"
#include "base/RcRunId.h"

struct RunDocumentMeta
{
    friend bool operator==(const RunDocumentMeta &, const RunDocumentMeta &) = default;

    ClientIndex topProgram;
    QDateTime startDateTime;
};
Q_DECLARE_METATYPE(RunDocumentMeta)

struct RunDocument
{
    RunDocument() = default;
    RunDocument(const RcRunId &runId, const ClientIndex &index, const QJsonObject &cfg);

    friend bool operator==(const RunDocument &, const RunDocument &) = default;
    void setMeta(const ClientIndex &top);
    bool merge(const RunDocument &doc);

    RcRunId runId;
    RunDocumentMeta meta;
    QMap<ClientIndex, QJsonObject> programs;
    QMap<DeviceIndex, QJsonObject> devHw;
    QMap<DeviceIndex, QJsonObject> devFw;
    QMap<DeviceIndex, QJsonObject> devCal;
};
Q_DECLARE_METATYPE(RunDocument)

#endif // RUNDOCUMENT_H
