/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "StatCounter.h"

uint64_t StatCounter::update_with_rollover_fix(uint64_t wide, uint64_t newval, int width)
{
    uint64_t carry = (uint64_t)1 << width;
    uint64_t mask  = carry - 1;
    int64_t delta = newval - (wide & mask);
    if (delta < 0)
        delta += carry;
    wide += delta;
    return wide;
}

uint64_t StatCounter::update_with_rollover_fix(uint64_t wide, uint32_t newval)
{
    return update_with_rollover_fix(wide, newval, 32);
}

uint64_t StatCounter::update_with_rollover_fix(uint64_t wide, uint16_t newval)
{
    return update_with_rollover_fix(wide, newval, 16);
}
