/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TRIGGERHISTOGRAMDATA_H
#define TRIGGERHISTOGRAMDATA_H

#include <QMap>
#include <QMetaType>
#include <QVector>
#include <QtGlobal>

struct TriggerHistogramChannelData
{
    bool isEmpty() const;
    int getFirstNotemptyBin() const;
    int getLastNotemptyBin() const;

    QVector<double> px;
    QVector<quint32> data;
    quint64 overflowCount = 0;
    quint32 spillCount = 0;         // duplicated TriggerHistogramData::spillCount
    quint32 spillCurrentTimeMs = 0; // duplicated TriggerHistogramData::spillCurrentTimeMs
    quint32 channel = 0;
    QString channelDescr;
};

Q_DECLARE_METATYPE(TriggerHistogramChannelData)

struct TriggerHistogramData
{
    QMap<int, TriggerHistogramChannelData> histograms;
    quint32 spillCount = 0;
    quint32 spillCurrentTimeMs = 0;
};
Q_DECLARE_METATYPE(TriggerHistogramData)

#endif // TRIGGERHISTOGRAMDATA_H
