/*
**    Copyright 2013-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/


#ifndef CALAVGCONFIG_H
#define CALAVGCONFIG_H

#include <QVector>
#include <QMetaType>

class CalAvgConfig
{
public:
    void clear();

    friend bool operator==(const CalAvgConfig &, const CalAvgConfig &) = default;
    CalAvgConfig &operator+=(const CalAvgConfig &rhs);
    friend CalAvgConfig operator+(CalAvgConfig lhs, const CalAvgConfig &rhs)
    { lhs += rhs; return lhs; }

    QVector<double> samples;
    double offset = 0;
};

Q_DECLARE_METATYPE(CalAvgConfig)

#endif // CALAVGCONFIG_H
