/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SDBDEVICE_H
#define SDBDEVICE_H

#include <QString>

struct SdbProduct
{
    friend bool operator==(const SdbProduct &, const SdbProduct &) = default;
    uint64_t vendor_id;
    uint32_t device_id;
    QString version;
    QString date; // TODO: QDate
    QString name;
};

struct SdbComponent
{
    friend bool operator==(const SdbComponent &, const SdbComponent &) = default;
    uint64_t addr_first;
    uint64_t addr_last;
    SdbProduct product;
};

struct SdbDevice
{
    friend bool operator==(const SdbDevice &, const SdbDevice &) = default;
    //    uint16_t abi_class;
    uint8_t abi_ver_major;
    uint8_t abi_ver_minor;
    uint32_t bus_specific;
    SdbComponent component;
};

#endif // SDBDEVICE_H
