/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef IPPORTPAIR_H
#define IPPORTPAIR_H

#include <QString>

class IpPortPair
{
public:
    IpPortPair(quint32 ip = 0, quint16 port = 0)
        : ip(ip), port(port) { }

    static IpPortPair parse(const QString &s);
    QString toString() const;

    quint32 ip = 0;
    quint16 port = 0;
};

#endif // IPPORTPAIR_H
