/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "Ipv4PrefixFactory.h"

#include "base/Ipv4Prefix.h"

QMap<Ipv4Prefix, QString> Ipv4PrefixFactory::create()
{
    QMap<Ipv4Prefix, QString> map;
    // TODO: make configurable
    map[Ipv4Prefix("0.0.0.0/0")] = "_All_";
    map[Ipv4Prefix("159.93.0.0/16")] = "JINR GPN";
    map[Ipv4Prefix("159.93.126.0/24")] = "Nuclotron GPN";
    map[Ipv4Prefix("192.168.0.0/16")] = "JINR Intranet";
    map[Ipv4Prefix("192.168.126.0/24")] = "Nuclotron Intranet";
    map[Ipv4Prefix("10.18.0.0/16")] = "TechNet";
    map[Ipv4Prefix("10.18.95.0/24")] = "BMN White Rabbit Network";
    map[Ipv4Prefix("10.18.69.0/24")] = "AFI-DAQ Network";
    map[Ipv4Prefix("10.18.92.0/24")] = "BMN-DAQ Network";
    map[Ipv4Prefix("10.18.93.0/24")] = "BMN-DAQ Optic Network";
    map[Ipv4Prefix("10.18.94.0/24")]= "MPD-TEST-DAQ Network";
    return map;
}
