#ifndef SUBNETLISTWIDGET_H
#define SUBNETLISTWIDGET_H

#include <QListWidget>
#include "base/Ipv4Prefix.h"

class LldpInfoCache;

class SubnetListWidget : public QListWidget
{
    Q_OBJECT
public:
    explicit SubnetListWidget(QWidget *parent = nullptr);

signals:
    void setNetworkFilter(const Ipv4PrefixList &filter);

public slots:
    void lldpCacheUpdated(const LldpInfoCache &cache);

protected:
    void selectionChanged(const QItemSelection &selected, const QItemSelection &deselected) override;

private:
    void fillKnownNetworks();
    void addSubnet(const Ipv4Prefix& subnet, QString name=QString());

    Ipv4PrefixList knownSubnets;
};

#endif // SUBNETLISTWIDGET_H
