/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ABSTRACTEASYDEVICEMODULE_H
#define ABSTRACTEASYDEVICEMODULE_H

#include "AbstractDeviceModule.h"

class AbstractEasyDeviceModule : public AbstractDeviceModule
{
public:
    AbstractEasyDeviceModule(const MregBusInterface &bus);

    bool regOpExecRebased(mlink::RegOpVector &data);
    bool regRead16(quint16 relAddr, quint16 *data);
    bool regWrite16(quint16 relAddr, quint16 data);
    bool regRead32(quint16 relAddr, quint32 *data);
    bool regWrite32(quint16 relAddr, quint32 data);
    bool regRead64(quint16 relAddr, quint64 *data);
    bool regWrite64(quint16 relAddr, quint64 data);

private:
    static mlink::RegOpVector regOpRebase(const mlink::RegOpVector &data, quint16 baseAddr);
};

#endif // ABSTRACTEASYDEVICEMODULE_H
