#ifndef FELINKREGS_H
#define FELINKREGS_H

// FE-Link V1.0 CSR
enum {
    REG_FELINK_CTRL                  = 0x00, // R/W
    REG_FELINK_STATUS                = 0x01, // RO
    REG_FELINK_RX_BITSLIDE           = 0x02, // RO
    REG_FELINK_REMOTE_VER            = 0x03, // RO
    REG64_FELINK_REMOTE_ID           = 0x04, // RO
    REG_FELINK_SYNC_RESEND_TIME      = 0x08, // R/W
    REG_FELINK_TIME_FRAME_TIMEOUT    = 0x09, // R/W
    REG32_FELINK_TAI_NSEC            = 0x0A, // RO
    REG64_FELINK_TAI_SEC             = 0x0C, // RO
    REG32_FELINK_LINK_STATE_TIME     = 0x10, // RO
    REG32_FELINK_CNT_RX_CODE_ERROR   = 0x14, // RO
    REG32_FELINK_CNT_RX_CRC_ERROR    = 0x16, // RO
    REG32_FELINK_CNT_TIME_FRAMES_SND = 0x18, // RO
    REG32_FELINK_CNT_TRIG_FRAMES_SND = 0x1A, // RO
    REG32_FELINK_CNT_TIME_FRAMES_RCV = 0x1C, // RO
    REG32_FELINK_CNT_TRIG_FRAMES_RCV = 0x1E, // RO
    REG32_FELINK_CNT_UNKNOWN_FRAMES  = 0x20, // RO
};

enum {
    REG32_GLOB_ID             = 0x00,
    REG_GLOB_CTRL             = 0x02,
    REG_GLOB_LOCK             = 0x03,
    REG_GLOB_CH_NUM           = 0x04,
    REG_GLOB_START_ADDR       = 0x05,
    REG_GLOB_ADDR_SIZE_PER_CH = 0x06,
};

enum { 
    REG_CH_CTRL               = 0x00,
    REG_CH_PHY_LEV_CTRL       = 0x01,
    REG32_CH_INFO             = 0x02, // RO
    REG_CH_VER                = 0x04, // RO
    REG_CH_STATUS             = 0x05, // RO
    REG_CH_RX_BITLIDE         = 0x06, // RO
    REG_CH_REMORE_VER         = 0x07, // RO
    REG64_CH_REMORE_ID        = 0x08, // RO
    REG32_CH_REMORE_INFO      = 0x0C, // RO
    REG64_CH_TAI_SEC          = 0x10, // RO
    REG32_CH_TAI_NSEC         = 0x14, // RO
    REG32_CH_LINK_STATE_TIME  = 0x18, // RO
    REG_CH_SYNC_RESEND_TIME   = 0x1A,
    REG_CH_TIMEOUT_SYNC       = 0x1B,
    REG_CH_TIMEOUT_TIME_FRAME = 0x1C,
    REG_CH_BAD_PKT_WEIGHT     = 0x1D,
    REG_CH_BAD_PKT_THRESHOLD  = 0x1E,
    REG32_CH_GTX_CTRL         = 0x20,
    REG32_CH_GTX_STATUS       = 0x22, // RO

    REG32_CH_CNT_RX_CODE_ERROR   = 0x40, // RO
    REG32_CH_CNT_RX_CRC_ERROR    = 0x42, // RO

    REG32_CH_CNT_SYNC_FRAMES_SND = 0x44, // RO
    REG32_CH_CNT_SYNC_FRAMES_RCV = 0x46, // RO
    REG32_CH_CNT_TIME_FRAMES_SND = 0x48, // RO
    REG32_CH_CNT_TIME_FRAMES_RCV = 0x4A, // RO
    REG32_CH_CNT_TRIG_FRAMES_SND = 0x4C, // RO
    REG32_CH_CNT_TRIG_FRAMES_RCV = 0x4E, // RO
    REG32_CH_CNT_XOFF_FRAMES_SND = 0x50, // RO
    REG32_CH_CNT_XOFF_FRAMES_RCV = 0x52, // RO
    REG32_CH_CNT_DATA_FRAMES_SND = 0x54, // RO
    REG32_CH_CNT_DATA_FRAMES_RCV = 0x56, // RO

    REG32_CH_CNT_UNKNOWN_FRAMES  = 0x58, // RO
    REG32_CH_CNT_RESET_PHY       = 0x5A, // RO
};

enum {
    REG_FELINK_CTRL_BIT_CNT_LOCK = 0x0002,
};

#endif // FELINKREGS_H
