/*
**    Copyright 2011-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "HrbModuleConfig.h"

HrbModuleConfig::HrbModuleConfig()
{
    setThreshold(0);
}

void HrbModuleConfig::setThreshold(double val)
{
    for (int i = 0; i < ASD8_COUNT; i++)
        thr[i] = val;
}

void HrbModuleConfig::spreadGlobalCfg(const HrbModuleConfig &cfg)
{
    HrbModuleConfig newConfig(cfg);
    newConfig.mergeLocalData(*this);
    *this = newConfig;
}

void HrbModuleConfig::mergeLocalData(const HrbModuleConfig &cfg)
{
    thr = cfg.thr;
}
