#ifndef RCTRIGMODULE_H
#define RCTRIGMODULE_H

#include "device-modules/BaseDeviceModule.h"

struct RcTrigConfig;

class RcTrigModule : public BaseDeviceModule<RcTrigModule>
{
public:
    explicit RcTrigModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const RcTrigConfig &cfg);

private:
    mlink::RegOpVector setTrigTimerFreqCmd(double freq);
    mlink::RegOpVector setTrigRandomFreqCmd(double freq);
    mlink::RegOpVector setTrigRandomDeadTimeCmd(double microseconds);

    double devClockFreq = 125000000;
};

#endif // RCTRIGMODULE_H
