#include "TluDecDesConfigConverter.h"

#include "TluDecDesConfig.h"

namespace {
// TluDecDesConfig
constexpr const char *k_chReset = "chReset";
}

// -------------- TluDecDesConfig
template<>
bool AbstractConfigConverter<TluDecDesConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<TluDecDesConfig>::toJsonObject(const TluDecDesConfig &in)
{
    QVariantMap m;
    m[k_chReset] = ConfigConverterUtil::toJsonValue(in.chReset);
    return fromVariantMap(m);
}

template<>
TluDecDesConfig AbstractConfigConverter<TluDecDesConfig>::fromJsonObject(const QJsonObject &in)
{
    TluDecDesConfig out;
    out.chReset = ConfigConverterUtil::toVector<bool>(in[k_chReset]);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<TluDecDesConfig>::toJsonValue(const TluDecDesConfig &in)
{
    return toJsonObject(in);
}

template<>
TluDecDesConfig AbstractConfigConverter<TluDecDesConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<TluDecDesConfig>::registerSubTypes()
{
}
