#ifndef SINGLESERDESDELAYWIDGET_H
#define SINGLESERDESDELAYWIDGET_H

#include <QWidget>

class AdcSerDesDelay;
namespace Ui {
class SingleSerDesDelayWidget;
}

class SingleSerDesDelayWidget : public QWidget
{
    Q_OBJECT

public:
    explicit SingleSerDesDelayWidget(int id, QWidget *parent = nullptr);
    ~SingleSerDesDelayWidget();
    int getId() const { return id; }
    AdcSerDesDelay getDelay() const;
    void setDelay(const AdcSerDesDelay &delay);
    void setControlEnabled(bool);

signals:
    void clockUpdated(int id, int val) const;
    void dataUpdated(int id, int val) const;

private slots:
    void on_spinBoxClock_valueChanged(int val);
    void on_spinBoxData_valueChanged(int val);

private:
    Ui::SingleSerDesDelayWidget *ui;
    int id;
};

#endif // SINGLESERDESDELAYWIDGET_H
