#include "DlnpCalibrationTriggerDialog.h"

#include <QVBoxLayout>
#include "DlnpCalibrationTriggerWidget.h"

DlnpCalibrationTriggerDialog::DlnpCalibrationTriggerDialog(QWidget *parent)
    : QDialog(parent)
{
    QVBoxLayout *mainLayout = new QVBoxLayout(this);
    auto w = new DlnpCalibrationTriggerWidget(this);
    mainLayout->addWidget(w);
    setWindowTitle("DLNP Calibration Trigger");

    setLayout(mainLayout);
    connect(w, &DlnpCalibrationTriggerWidget::dlnpCalibrationTriggerConfigChanged,
            this, &DlnpCalibrationTriggerDialog::dlnpCalibrationTriggerConfigChanged);

    connect(this, &DlnpCalibrationTriggerDialog::setDlnpCalibrationTriggerConfig,
            w, &DlnpCalibrationTriggerWidget::setDlnpCalibrationTriggerConfig);

    connect(this, &DlnpCalibrationTriggerDialog::dlnpCalibrationTriggerBpUpdated,
            w, &DlnpCalibrationTriggerWidget::dlnpCalibrationTriggerBpUpdated);
}
