#ifndef FELINKTREEMODELITEM_H
#define FELINKTREEMODELITEM_H

#include "base/DeviceIndex.h"

struct FeLinkTreeModelItem
{
    explicit FeLinkTreeModelItem(FeLinkTreeModelItem *p = nullptr) : parent(p) {
        if(p)
            dev = p->dev;
    }
    ~FeLinkTreeModelItem() {
        qDeleteAll(children);
    }
    FeLinkTreeModelItem *child(int row) const { return children.value(row, nullptr); }
    void addChild(FeLinkTreeModelItem *child) { children.push_back(child); }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<FeLinkTreeModelItem*>(this));
        return 0;
    }

    DeviceIndex dev;
    int ch=-1;
    FeLinkTreeModelItem *parent;
    QVector<FeLinkTreeModelItem *> children;
};

#endif // FELINKTREEMODELITEM_H
