#ifndef HPTDCADJUSTDIALOG_H
#define HPTDCADJUSTDIALOG_H

#include <QDialog>

#include "device-modules/TdcCore/TdcCoreConfig.h"

namespace Ui {
class HptdcAdjustDialog;
}

class QAbstractButton;

class HptdcAdjustDialog : public QDialog
{
    Q_OBJECT
public:
    explicit HptdcAdjustDialog(QWidget *parent = nullptr);
    ~HptdcAdjustDialog();

signals:
    void configChanged(const HptdcAdjustConfig &);

public slots:
    void setConfig(const HptdcAdjustConfig &s);
    void activate_dialog();

private slots:
    void on_comboBox_readout_fifo_currentIndexChanged(int index);
    void on_comboBoxLeadRes_currentIndexChanged(int);
    void on_checkBox_pairing_mode_clicked(bool checked);
    void on_comboBox_core_clock_source_currentIndexChanged(int index);
    void on_buttonBox_clicked(QAbstractButton *button);

private:
    void write_setup();
    void updateLabels();

    Ui::HptdcAdjustDialog *ui;
    HptdcAdjustConfig adjust_set;
};

#endif // HPTDCADJUSTDIALOG_H
