#ifndef HPTDCSTATUSDIALOG_H
#define HPTDCSTATUSDIALOG_H

#include <QDialog>

struct TdcCoreStatus;
class HptdcStatusModel;
class DeviceIndex;
class DeviceIndexEnabledMap;
namespace Ui {
class HptdcStatusDialog;
}

class HptdcStatusDialog : public QDialog
{
    Q_OBJECT

public:
    explicit HptdcStatusDialog(QWidget *parent = nullptr);
    ~HptdcStatusDialog() override;

    // DeviceIndexEnabledMap subscribe
signals: void deviceListChanged(const DeviceIndexEnabledMap &);
public slots: void setDeviceList(const DeviceIndexEnabledMap &new_devices);

public slots:
    void deviceStatusUpdated(const DeviceIndex &deviceIndex, const TdcCoreStatus &status);
    void setCurentDeviceIndex(const DeviceIndex &deviceIndex);

private:
    Ui::HptdcStatusDialog *ui;
    HptdcStatusModel * const model;
};

#endif // HPTDCSTATUSDIALOG_H
