/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef NETWORKPORTWIDGET_H
#define NETWORKPORTWIDGET_H

#include <QWidget>
#include "device-modules/NetworkPort/NetworkPortConfig.h"

namespace Ui {
class NetworkPortWidget;
}

class NetworkPortWidget : public QWidget
{
    Q_OBJECT

public:
    explicit NetworkPortWidget(QWidget *parent = nullptr);
    virtual ~NetworkPortWidget() override;
    NetworkPortConfig getConfig() const { return cfg; }

public slots:
    void setConfig(const NetworkPortConfig &newConfig);

private slots:
    void on_spinBoxMtu_valueChanged(int value);
    void on_pushButtonResetMstream_clicked();
    void on_spinBoxDefragTimeout_valueChanged(int value);
    void on_spinBoxRetxTimeout_valueChanged(int value);

signals:
    void configChanged(const NetworkPortConfig &config);
    void mstreamReset();

private:
    void updateGui();

    Ui::NetworkPortWidget *ui;
    NetworkPortConfig cfg;
};

#endif // NETWORKPORTWIDGET_H
