#ifndef WRSTATUSTABLEHELPER_H
#define WRSTATUSTABLEHELPER_H

#include <optional>
#include <QVector>

class QTableWidget;
struct WrStatus;
class QVariant;
class QModelIndex;

class  WrStatusTableHelper
{
public:
    enum Columns {
        COL_UPTIME, COL_TIME, COL_TIME_OFFSET,
        COL_LINK_ERROR, COL_SYNC_LOST, COL_RX_CODE_ERROR,
        COL_TOTAL
    };

    static QVector<int> optionalColumns(int colOffset = 0);
    static void setHeaderWrStatus(QTableWidget *table, int colOffset);
    static void updateDevWrStatus(QTableWidget *table, int colOffset, int row, const std::optional<WrStatus> &wrStatus);

    static QVariant data(const std::optional<WrStatus> &status, int col, int role);
    static QVariant headerData(int col, int role);

    static QVector<Columns> hiddenColumns();
};

#endif // WRSTATUSTABLEHELPER_H
