#ifndef MSTREAMSTATISTICDIALOG_H
#define MSTREAMSTATISTICDIALOG_H

#include <QDialog>

#include "base/DeviceIndexEnabled.h"

#include "MStreamStatisticWidget.h"

namespace Ui {
class MStreamStatisticDialog;
}

class MStreamStatisticDialog : public QDialog
{
    Q_OBJECT

public:
    explicit MStreamStatisticDialog(QWidget *parent = nullptr);
    ~MStreamStatisticDialog();

public slots:
    void setDeviceList(const DeviceIndexEnabledMap &new_devices);

signals:
    void deviceListChanged(const DeviceIndexEnabledMap &);
    void stat_updated(const MStreamStat &ms_stat);
    void stat_from_receiver_updated(const ReceiverStat &stat);

    void set_run_state(bool run);

private:
    Ui::MStreamStatisticDialog *ui;
};

#endif // MSTREAMSTATISTICDIALOG_H
