#include "RcClientConfigConverter.h"

#include "RcClientConfig.h"
#include "base/ConfigConverterUtil.h"

namespace {
// constexpr const char *k_index = "index";
constexpr const char *k_en = "en";
constexpr const char *k_evNumCheck = "evNumCheck";
}


template<>
bool AbstractConfigConverter<RcClientConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<RcClientConfig>::toJsonObject(const RcClientConfig &in)
{
    QVariantMap m;
    // m[k_index] = QVariant::fromValue(in.index);
    m[k_en] = QVariant::fromValue(in.en);
    m[k_evNumCheck] = QVariant::fromValue(in.evNumCheck);
    return fromVariantMap(m);
}

template<>
RcClientConfig AbstractConfigConverter<RcClientConfig>::fromJsonObject(const QJsonObject &m)
{
    RcClientConfig out;
    // update_value(m, k_index, &out.index);
    update_value(m, k_en, &out.en);
    update_value(m, k_evNumCheck, &out.evNumCheck);

    return out;
}

template<>
QJsonValue AbstractConfigConverter<RcClientConfig>::toJsonValue(const RcClientConfig &in)
{
    return toJsonObject(in);
}

template<>
RcClientConfig AbstractConfigConverter<RcClientConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<RcClientConfig>::registerSubTypes()
{
    AbstractConfigConverter<ClientIndex>::registerTypes();
}

// ---
