#ifndef TRIGDEVICEMGRFSM_H
#define TRIGDEVICEMGRFSM_H

#include "fsm/DeviceMgrFsm.h"

struct TrigDeviceMgrFsmInput : public DeviceMgrFsmInput
{
    bool hasStopEvNumber = false;
};

class TrigDeviceMgrFsm : public DeviceMgrFsm
{
    Q_OBJECT
public:
    TrigDeviceMgrFsm(QObject *p);
    void markStopEvNumber();
    void clearStopEvNumber();
    virtual bool isTransitionAllowed(const FsmState &toState) const override;

protected slots:
    virtual bool evaluate() override;

protected:
    virtual void printInputString(QDebug dbg) const override;
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;
    inline TrigDeviceMgrFsmInput *getInput() {
        return static_cast<TrigDeviceMgrFsmInput*>(BaseFsm::getInput());
    }
    inline const TrigDeviceMgrFsmInput *getInput() const {
        return static_cast<const TrigDeviceMgrFsmInput*>(BaseFsm::getInput());
    }
};

QDebug operator<<(QDebug dbg, const TrigDeviceMgrFsmInput &in);

#endif // TRIGDEVICEMGRFSM_H
