/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "ZmqMonitor.h"

#include <QDebug>

class connect_monitor_t: public zmq::monitor_t
{
public:
};

ZmqMonitor::ZmqMonitor(zmq::socket_t &sock, std::string const &addr, QObject *parent)
    : QObject(parent),
    zmq::monitor_t(),
    addr(addr)
{
    setObjectName("ZmqMonitor");
    try {
        // monitor(sock, addr, ZMQ_EVENT_ALL); // never returns
    } catch (std::exception &e) {
        qCritical().nospace() << __func__ << ": " << e.what();
    }
}

void ZmqMonitor::on_event_connected(const zmq_event_t& event,
                        const char* addr)
{
    qDebug() << "connected " + QString::fromLatin1(addr);
}
