//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//


#include <QDebug>
#include "qxw/HistoView.h"
#include "qxw/QxwHist.h"

HistoView::HistoView(QWidget *parent) :
        WaveformView(parent)
{
}

void HistoView::attach(const QxwHist &histogram)
{
    connect(&histogram, SIGNAL(changed()), SLOT(histChanged()));
}

void HistoView::detach()
{
    disconnect(this, SLOT(histChanged()));
}

void HistoView::histChanged()
{
    qDebug() << "histChanged() sender=" << sender()->objectName();
}
