//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//


#include "qwt_plot_canvas.h"
#include "qxw/QxwZoomer.h"
#include <QDebug>
#include <QString>

QxwZoomer::QxwZoomer(QwtPlotCanvas *canvas):
        QwtPlotZoomer(canvas)
{
    setTrackerMode(QwtPicker::AlwaysOn);
}

QwtText QxwZoomer::trackerText(const QwtDoublePoint &pos) const
{
    QColor bg(Qt::white);
#if QT_VERSION >= 0x040300
    bg.setAlpha(200);
#endif

    //        QwtText text = QString("%1 - %2").arg(pos.x()).arg(pos.y());
    QwtText text = QwtPlotZoomer::trackerText(pos);
    text.setBackgroundBrush( QBrush( bg ));
    text.setText(QString::number(pos.x(),'f',6) +", " + QString::number(pos.y(),'f',6));
    return text;
}

void 	QxwZoomer::zoom (int up)
{
//    qDebug() << QString("Base top:%1; bottom:%2; left:%3; right:%4")
//              .arg(zoomBase().top())
//              .arg(zoomBase().bottom())
//              .arg(zoomBase().left())
//              .arg(zoomBase().right());
//    qDebug() << QString("Base top:%1; bottom:%2; left:%3; right:%4")
//              .arg(zoomRect().top())
//              .arg(zoomRect().bottom())
//              .arg(zoomRect().left())
//              .arg(zoomRect().right());
//    qDebug() << QString("zoomIndex=%1")
//                .arg(zoomRectIndex());
    QwtPlotZoomer::zoom(up);
}
